/*
  +----------------------------------------------------------------------+
  | Hidef                                                                |
  +----------------------------------------------------------------------+
  | Copyright (c) 2007 The PHP Group                                     |
  +----------------------------------------------------------------------+
  | This source file is subject to version 3.01 of the PHP license,      |
  | that is bundled with this package in the file LICENSE, and is        |
  | available through the world-wide-web at the following url:           |
  | http://www.php.net/license/3_01.txt                                  |
  | If you did not receive a copy of the PHP license and are unable to   |
  | obtain it through the world-wide-web, please send a note to          |
  | license@php.net so we can mail you a copy immediately.               |
  +----------------------------------------------------------------------+
  | Authors: Gopal Vijayaraghavan <gopalv@php.net>                       |
  +----------------------------------------------------------------------+
*/

/* $Id: php_hidef.h 299904 2010-05-28 12:52:58Z gopalv $ */

#ifndef PHP_HIDEF_H
#define PHP_HIDEF_H

extern zend_module_entry hidef_module_entry;
#define phpext_hidef_ptr &hidef_module_entry

#define PHP_HIDEF_VERSION "0.1.2"

#ifdef PHP_WIN32
#define PHP_HIDEF_API __declspec(dllexport)
#else
#define PHP_HIDEF_API
#endif

#ifdef ZTS
#include "TSRM.h"
#endif

#if ZEND_MODULE_API_NO > 20060613
#define ZEND_ENGINE_2_3
#endif

#if PHP_MAJOR_VERSION == 5 && PHP_MINOR_VERSION == 3 && PHP_RELEASE_VERSION < 2
#define ZEND_BROKEN_INI_SCANNER 1
#endif

PHP_MINIT_FUNCTION(hidef);
PHP_MSHUTDOWN_FUNCTION(hidef);
PHP_MINFO_FUNCTION(hidef);


/* {{{ zend_hidef_globals */
ZEND_BEGIN_MODULE_GLOBALS(hidef)
	/* configuration parameters */
	char *ini_path;		/* search path for ini files */
	char *data_path;	/* search path for the data files */
	zval* data_hash;	/* hash storing the data */
ZEND_END_MODULE_GLOBALS(hidef)
/* }}} */

/* {{{ extern hidef_globals */
ZEND_EXTERN_MODULE_GLOBALS(hidef)
/* }}} */

#ifdef ZTS
#define HIDEF_G(v) TSRMG(hidef_globals_id, zend_hidef_globals *, v)
#else
#define HIDEF_G(v) (hidef_globals.v)
#endif

#endif	/* PHP_HIDEF_H */


/*
 * Local variables:
 * tab-width: 4
 * c-basic-offset: 4
 * End:
 * vim>600: noet sw=4 ts=4 fdm=marker
 * vim<600: noet sw=4 ts=4
 */
